<?php 


function fop2admin_get_config($engine) {
    // Executed on APPLY in FreePBX, we regenerate the fop2buttons if needed
    global $amp_conf, $db, $active_modules;

    $ver = getversion();
    $ver = str_replace(".","",substr($ver,0,3));

    if($ver>25) {
       $qctx="from-queue";
    } else {
       $qctx="from-internal";
    }

    $fopbutton        = fop2_all_freepbx_buttons();
    $botonesdefinidos = fop2_list_botones();

    foreach ($botonesdefinidos as $devname => $datarray) {
       if(!array_key_exists($devname,$fopbutton)) {
           $results = sql("SELECT id FROM fop2buttons WHERE device='$devname'","getRow",DB_FETCHMODE_ASSOC);
           $boton_id_a_borrar  = $results['id'];
           fop2_del_button($boton_id_a_borrar);
       }
    }

    $fp2=fopen("/tmp/fop2adminget.log","w");
    foreach ($fopbutton as $devname => $datarray) {
       $tipocorto = substr($datarray['type'],0,-1);
       if($tipocorto == "extension") {
           $cfstring="CF/".$datarray['exten'];
           $qchanstr="Local/".$datarray['exten']."@$qctx/n";
       } else {
           $cfstring="NULL";
           $qchanstr="NULL";
       }
       if(!isset($botonesdefinidos[$devname])) {
            $query = "REPLACE INTO fop2buttons (type, device, privacy, label, exten, context, mailbox, queuechannel, customastdb) ".
                            "VALUES ('$tipocorto', '".$db->escapeSimple($devname)."', '', '".$db->escapeSimple($datarray['name']).
                            "','".$datarray['exten']."','".$datarray['context']."','".$datarray['mailbox']."','$qchanstr','$cfstring')\n";
            fputs($fp2,$query);
           
            $results = sql( "REPLACE INTO fop2buttons (type, device, privacy, label, exten, context, mailbox, queuechannel, customastdb) ".
                            "VALUES ('$tipocorto', '".$db->escapeSimple($devname)."', '', '".$db->escapeSimple($datarray['name']).
                            "','".$datarray['exten']."','".$datarray['context']."','".$datarray['mailbox']."','$qchanstr','$cfstring')");
            if(DB::IsError($results)) {
                die($results->getMessage());
            } else { 
                $botonesdefinidos[$devname]=1; 
            };
        }
    }
    fclose($fp2);

    $query = "SELECT data FROM parkinglot WHERE keyword='parkext'";
    $results = sql($query,"getRow",DB_FETCHMODE_ASSOC);
    $parkext = $results['data'];

    $query = "SELECT exten FROM fop2buttons WHERE type='park'";
    $results = sql($query,"getRow",DB_FETCHMODE_ASSOC);
    $parkextfop = $results['exten'];

    if($parkext <> $parkextfop) {
        $query = "UPDATE fop2buttons SET exten='$parkext' WHERE type='park' AND exten='$parkextfop'";
        $results = sql($query);
    }
   
    $allbuttons= fop2_list_buttons();
    $buttonsid = array();
    foreach ($allbuttons as $devname => $datarray) {
       $buttonsid[]=$datarray['id'];
    }

}

function fop2_all_freepbx_buttons() {

    global $active_modules, $amp_conf, $db;

    $mydevices = fop2_getDeviceId();

    if (function_exists("framework_check_extension_usage")) {
        $full_list = framework_check_extension_usage(true,array('queues'=>1,'conferences'=>1,'core'=>1));
    } else {
        $full_list = oldfreepbx_check_extension_usage(true);
    }

    $fopdevice   = array();
    $fopmailbox  = array();
    $fopprivacy  = array();
    $foplabel    = array();
    $fopgroup    = array();
    $fopemail    = array();
    $fopqchannel = array();
    $fopochannel = array();
    $fopcustastdb= array();
    $fopspyoption= array();

    if ($amp_conf['AMPEXTENSIONS'] == "deviceanduser") {
        //users
        $sql = "SELECT extension,concat('USER/',extension) AS dial,";
        $sql.= "if(voicemail='novm','',concat(extension,'@',voicemail)) AS mailbox FROM users ";
        $sql.= "LEFT JOIN devices ON users.extension=devices.id";
    } else {
        // extensions
        $sql = "SELECT extension,if(dial is null,concat('USER/',extension),dial) AS dial,";
        $sql.= "if(voicemail='novm','',CONCAT(extension,'@',voicemail)) AS mailbox FROM users ";
        $sql.= "LEFT JOIN devices ON users.extension=devices.id";
    }
    $results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    foreach ($results as $result) {
        $fopdevice[$result['extension']]=$result['dial'];
        $fopmailbox[$result['extension']]=$result['mailbox'];
    }
    $sql = "SELECT exten,privacy,label,`group`,email,channel,queuechannel,originatechannel,customastdb,spyoptions,external FROM fop2buttons";
    $results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if(DB::IsError($results)) {
        die($results->getMessage());
    }
    foreach ($results as $result) {
        $fopprivacy[$result['exten']]   = $result['privacy'];
        $foplabel[$result['exten']]     = $result['label'];
        $fopgroup[$result['exten']]     = $result['group'];
        $fopemail[$result['exten']]     = $result['email'];
        $fopchannel[$result['exten']]   = $result['channel'];
        $fopqchannel[$result['exten']]  = $result['queuechannel'];
        $fopochannel[$result['exten']]  = $result['originatechannel'];
        $fopcustastdb[$result['exten']] = $result['customastdb'];
        $fopspyoption[$result['exten']] = $result['spyoptions'];
        $fopexternal[$result['exten']]  = $result['external'];
    }

    foreach ($full_list as $key => $value) {
        foreach ($value as $exten => $item) {
            if($key=="featurecodeadmin") continue;

            $description = explode(":",$item['description'],2);
            $devname = "";
            $devtype = "";
            $privacy = "";
            $group   = "";
            $email   = "";
            $qchannel= "";
            $channel = "";
            $ochannel= "";
            $custastdb="";
            $spyoptions="";
            $external="";

            if($key == "conferences") {
                $devname="CONFERENCE/".$exten;
                $devtype="conferences";
                $context="from-internal";
                $mbox='';
            } else if($key == "core") {
                $devname=$fopdevice[$exten];
                $mbox=(isset($fopmailbox[$exten])?$fopmailbox[$exten]:'');
                $privacy=(isset($fopprivacy[$exten])?$fopprivacy[$exten]:'');
                $group=(isset($fopgroup[$exten])?$fopgroup[$exten]:'');
                $email=(isset($fopemail[$exten])?$fopemail[$exten]:'');
                $channel=(isset($fopchannel[$exten])?$fopchannel[$exten]:'');
                $qchannel=(isset($fopqchannel[$exten])?$fopqchannel[$exten]:'');
                $ochannel=(isset($fopochannel[$exten])?$fopochannel[$exten]:'');
                $custastdb=(isset($fopcustastdb[$exten])?$fopcustastdb[$exten]:'');
                $spyoptions=(isset($fopspyoption[$exten])?$fopspyoption[$exten]:'');
                $external=(isset($fopexternal[$exten])?$fopexternal[$exten]:'');
                $devtype="extensions";
                $context="from-internal";
            } else if($key == "queues") {
                $devname="QUEUE/".$exten;
                $devtype="queues";
                $context="ext-queues";
                $mbox='';
            }
            //$finallabel = ($foplabel[$exten]?$foplabel[$exten]:trim($description[1]));
            $finallabel = (isset($foplabel[$exten])?$foplabel[$exten]:'');
            $myDevId = (isset($mydevices[$devname])?$mydevices[$devname]:'');

            if($devtype<>"") {
                $fopbutton[$devname] = Array('type'=>$devtype,    'exten'=>$exten,  'name'=>$finallabel, 'devid'=>$myDevId,
                                             'context'=>$context, 'mailbox'=>$mbox, 'privacy'=>$privacy, 'group'=>$group, 
                                             'email'=>$email, 'channel'=>$channel, 'queuechannel'=>$qchannel, 'originatechannel'=>$ochannel, 'customastdb'=>$custastdb, 
                                             'spyoptions'=>$spyoptions, 'external' =>$external);
            }
        }
    }

    $tresults = core_trunks_list();
    foreach ($tresults as $tresult) {
        // Trunk Config
        $devname = str_replace('AMP:', '', $tresult[1]);
        $devname = preg_replace('/(.*)\/\$OUTNUM\$$/','$1',$devname);
        $devtype = "trunks";
        $exten = $tresult[0];
        $myDevId = (isset($mydevices[$devname])?$mydevices[$devname]:'');
        $finallabel = (isset($foplabel[$exten])?$foplabel[$exten]:$devname);
        $privacy=(isset($fopprivacy[$exten])?$fopprivacy[$exten]:'');
        $michannels = (isset($fopemail[$tresult[0]])?$fopemail[$tresult[0]]:'');
        if(!isset($fopchannel[$exten])) { $fopchannel[$exten]=""; }
//        echo "trunk $exten ".$fopchannel[$exten]."<br>";
        $fopbutton[$devname] = Array('type'=>$devtype,'exten'=>$exten,'name'=>$finallabel,'devid'=>$myDevId,
                                     'context'=>'','mailbox'=>'','privacy'=>$privacy,'group'=>'','email'=>$michannels,
                                     'channel'=>$fopchannel[$exten],'customastdb'=>$devname);
    }

    if(function_exists("parking_getconfig")) {
        $results = parking_getconfig();
        $parkingenabled = isset($results['parkingenabled'])?$results['parkingenabled']:'';
        $parkext        = isset($results['parkext'])?$results['parkext']:70;


        $devid='';
        $results = sql("SELECT id,label FROM fop2buttons WHERE type='park' LIMIT 1","getAll",DB_FETCHMODE_ASSOC);
        
        if(is_array($results)){
            foreach($results as $result) {
                $devid = $result['id'];
                $label = $result['label'];
            }
        }


        if($parkingenabled<>'') { 
            $fopbutton['PARK/default'] = Array('type'=>'parks','exten'=>$parkext,'name'=>$label,'devid'=>$devid,'context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'');
        } else {
            $fopbutton['PARK/default'] = Array('type'=>'parks','exten'=>'700','name'=>$label,'devid'=>$devid,'context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'');
        }

    } else {
        # Default to standard parking on 700
        $fopbutton['PARK/default'] = Array('type'=>'parks','exten'=>'700','name'=>'Default','devid'=>'PARK/default','context'=>'parkedcalls','mailbox'=>'','privacy'=>'','group'=>'');
    }

    return $fopbutton;
}


function fop2_list_botones() {
    $ret = array();
    $results = sql("SELECT device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result) {
           $ret[$result['device']] = 1;
        }
    }
    return $ret;
}

function fop2_list_buttons() {
    $ret = array();
    $results = sql("SELECT id,type,exten,label FROM fop2buttons ORDER BY type,exten","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result) {
           $ret[] = $result;
        }
    }
    return $ret;
}


function fop2_list_users() {
    $results = sql("SELECT * FROM fop2users ORDER BY exten","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            // check to see if we have a dept match for the current AMP User.
            if (!isset($results['deptname']) || checkDept($result['deptname'])){
                // return this item's dialplan destination, and the description
                $allowed[] = $result;
            }
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_get_user($id){
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2users WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function fop2_chk_user($exten) {
    $results = sql("SELECT id FROM fop2users WHERE exten = '$exten'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}

function fop2_chk_group($name) {
    $results = sql("SELECT id FROM fop2groups WHERE name = '$exten'","getRow",DB_FETCHMODE_ASSOC);
    if ( is_null( $results) ) {
        return false;
    } else {
        return true;
    }
}


function fop2_add_user($post) {
    extract($post);
    if ( fop2_chk_user($userid) ) {
        echo "<script>javascript:alert(\"" . _("The user number is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }
    $valid_exten = array();
    $results = core_users_list();
    foreach($results as $key=>$val) {
       $valid_exten[]=$val[0];
    }
    if(!in_array($userid,$valid_exten)) {
        echo "<script>javascript:alert(\"" . _("The user number does not exist. Be sure to select a valid extension.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf)) 
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $results = sql("INSERT INTO fop2users (exten, secret, permissions) VALUES ('$userid', '$secret', '$strperm')");

    if($results==1) {

/* 
        $results = sql("SELECT id,name FROM fop2groups","getAll",DB_FETCHMODE_ASSOC);
        if(is_array($results)){
            foreach($results as $result){
                $grpid[$result['name']]=$result['id'];
            }
        }
*/
        foreach($post['includebot'] as $idx=>$chan){
            $results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$userid', '".$chan."')");
            //echo "($idx, $chan) INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$userid', '".$chan."')<br>";
        }
    }
    return true;
}

function fop2_getDeviceId() {
    $myreturn = array();
    $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $myreturn[$result['device']]=$result['id'];
        }
        return $myreturn;
    }
}

function fop2_get_user_groups($exten) {
    $exten = intval($exten);
    $ret = Array();
    $results = sql("SELECT id_group FROM fop2UserGroup WHERE exten='$exten'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_group'];
        }
        return $ret;
    } else {
        return "";
    }
}

function fop2_del_user($id) {
    $id = intval($id);
    $thisItem = fop2_get_user($id);
    $exten = $thisItem['exten'];
    $results = sql("DELETE FROM fop2UserGroup WHERE exten = '$exten'","query");
    $results = sql("DELETE FROM fop2users WHERE id = '$id'","query");
}

function fop2_buttonsrefresh($post) {
    global $db;
    $full_list = core_users_list();
    foreach($full_list as $dev => $datos) {
       $exten = $datos[0];
       $label = $db->escapeSimple($datos[1]);
       $query="UPDATE fop2buttons SET label='$label' WHERE exten='$exten'";
       $results = sql($query,"query");
    }
}

function fop2_buttonsedit($post) {
    global $db;
    $fp=fopen("/tmp/fop2admin.log","w");
    foreach($post as $key=>$val) {
        if(ereg("_",$key)) {
            $partes = split("_",$key);
            $field = $partes[0];
            $id    = $partes[1];
            $val   = $db->escapeSimple($val);
            if($field<>"name" && $field<>"privacy" && $field<>"channel" && $field<>"group" && $field<>"email" && $field<>'queuechannel' && $field<>'originatechannel' && $field<>'customastdb' && $field<>'spyoptions' && $field<>'external') { die($field); }
                if($field=="name") $field="label";
                $query = "UPDATE fop2buttons SET $field='$val' WHERE id='$id'";
                fputs($fp,$query."\n");
                $results = sql("UPDATE fop2buttons SET `$field`='$val' WHERE id='$id'","query");
        }
    }
    fclose($fp);
}

function fop2_edit_user($id, $post) {
    $id = intval($id);
    $thisItem = fop2_get_user($id);
    $exten = $thisItem['exten'];

    extract($post);

    if (!isset($needconf)) 
        $needconf = '';

    $allperm = strtolower($permissions);
    $allpermarr = preg_split("/\s+/",$allperm);
    $allpermarr = array_unique($allpermarr);
    $allpermarr = array_filter($allpermarr);

    if(in_array('all',$allpermarr)) {
        $strperm = "all";
    } else {
        $strperm = implode(",",$allpermarr);
    }

    $results = sql("UPDATE fop2users SET secret = '$secret', permissions='$strperm' WHERE id = '$id'");

    $results = sql("DELETE FROM fop2UserGroup WHERE exten = '$exten'","query");

    foreach($post['includebot'] as $idx=>$chan){
        $results = sql("INSERT INTO fop2UserGroup (exten,id_group) VALUES ('$exten', '$chan')");
    }
    return true;
}

function fop2_getlastid() {
    $valid_exten = array();
    $results = core_users_list();
    foreach($results as $key=>$val) {
       $valid_exten[]=$val[0];
    }
    asort($valid_exten);

    $existent_exten = array();
    $results = sql("SELECT exten FROM fop2users","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $existent_exten[]=$result['exten'];
        }
    }
    $disponibles = array_diff($valid_exten,$existent_exten);
    asort($disponibles);


    $proximodisponible = array_shift($disponibles);

    return $proximodisponible;
}

function oldfreepbx_check_extension_usage($exten=true, $module_hash=false) {
        global $active_modules;
        $exten_usage = array();

        if (!is_array($module_hash)) {
                $module_hash = $active_modules;
        }

        if (!is_array($exten) && $exten !== true) {
                $exten = array($exten);
        }
        foreach(array_keys($module_hash) as $mod) {
                $function = $mod."_check_extensions_oldfreepbx";
                if (function_exists($function)) {
                        $prev_domain = textdomain(NULL);
                        if (isset($_COOKIE['lang']) && is_dir("./modules/$mod/i18n/".$_COOKIE['lang'])) {
                                bindtextdomain($mod,"./modules/$mod/i18n");
                                bind_textdomain_codeset($mod, 'utf8');
                                textdomain($mod);
                                $module_usage = $function($exten);
                        } else {
                                textdomain('amp');
                                $module_usage = $function($exten);
                        }
                        if (!empty($module_usage)) {
                                $exten_usage[$mod] = $module_usage;
                        }
                        textdomain($prev_domain);
                }
        }
        if ($exten === true) {
                return $exten_usage;
        } else {
                foreach (array_keys($exten_usage) as $mod) {
                        foreach ($exten as $test_exten) {
                                if (isset($exten_usage[$mod][$test_exten])) {
                                        $exten_matches[$mod][$test_exten] = $exten_usage[$mod][$test_exten];
                                }
                        }
                }
        }
        return $exten_matches;
}

function core_check_extensions_oldfreepbx($exten=true) {
        global $amp_conf;

        $extenlist = array();
        if (is_array($exten) && empty($exten)) {
                return $extenlist;
        }
        $sql = "SELECT extension, name FROM users ";
        if (is_array($exten)) {
                $sql .= "WHERE extension in ('".implode("','",$exten)."')";
        }
        $sql .= " ORDER BY extension";
        $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

        foreach ($results as $result) {
                $thisexten = $result['extension'];
                $extenlist[$thisexten]['description'] = _("User Extension: ").$result['name'];
                $extenlist[$thisexten]['status'] = 'INUSE';
                $display = ($amp_conf['AMPEXTENSIONS'] == "deviceanduser")?'users':'extensions';
                $extenlist[$thisexten]['edit_url'] = "config.php?type=setup&display=$display&extdisplay=".urlencode($thisexten)."&skip=0";
        }
        return $extenlist;
}

function conferences_check_extensions_oldfreepbx($exten=true) {
        $extenlist = array();
        if (is_array($exten) && empty($exten)) {
                return $extenlist;
        }
        $sql = "SELECT exten, description FROM meetme ";
        if (is_array($exten)) {
                $sql .= "WHERE exten in ('".implode("','",$exten)."')";
        }
        $sql .= " ORDER BY exten";
        $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

        foreach ($results as $result) {
                $thisexten = $result['exten'];
                $extenlist[$thisexten]['description'] = _("Conference: ").$result['description'];
                $extenlist[$thisexten]['status'] = 'INUSE';
                $extenlist[$thisexten]['edit_url'] = 'config.php?display=conferences&extdisplay='.urlencode($thisexten);
        }
        return $extenlist;
}

function queues_check_extensions_oldfreepbx($exten=true) {
        global $active_modules;

        $extenlist = array();
        if (is_array($exten) && empty($exten)) {
                return $extenlist;
        }
        $sql = "SELECT extension, descr FROM extensions WHERE application='Queue' ";
        if (is_array($exten)) {
                $sql .= "AND extension in ('".implode("','",$exten)."')";
        }
        $sql .= " ORDER BY extension";
        $results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

        //$type = isset($active_modules['queues']['type'])?$active_modules['queues']['type']:'setup';
        foreach ($results as $result) {
                $thisexten = $result['extension'];
                $extenlist[$thisexten]['description'] = sprintf(_("Queue: %s"),$result['descr']);
                $extenlist[$thisexten]['status'] = _('INUSE');
                $extenlist[$thisexten]['edit_url'] = 'config.php?display=queues&extdisplay='.urlencode($thisexten);
        }

        return $extenlist;
}

function fop2_add_group($post) {

    global $db;
    extract($post);

    $name = mysql_real_escape_string($name);

    if ( fop2_chk_group($name) ) {
        echo "<script>javascript:alert(\"" . _("The group name is already in use.") . "\"); history.back(-1);</script>";
        return false;
    }

    if (!isset($needconf)) 
        $needconf = '';

    $results = sql("INSERT INTO fop2groups (name) VALUES ('$name')");

    if($results==1) {
        $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
        if(is_array($results)){
            foreach($results as $result){
                $butid[$result['device']]=$result['id'];
            }
        }

        foreach($post['includebot'] as $idx=>$chan){
            $results = sql("INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('$name', '".$butid[$chan]."')");
        }
    }

    return true;
}

function fop2_get_group($id) {
    //get all the variables for the meetme
    $results = sql("SELECT * FROM fop2groups WHERE id = '$id'","getRow",DB_FETCHMODE_ASSOC);
    return $results;
}

function  fop2_del_button($id) {
    $id = intval($id);
    $results = sql("DELETE FROM fop2GroupButton WHERE id_button = '$id'","query");
    $results = sql("DELETE FROM fop2buttons WHERE id = '$id'","query");
    return true;
}

function  fop2_del_group($id) {
    $id = intval($id);
    $thisItem = fop2_get_group($id);
    $name = $thisItem['name'];
    $results = sql("DELETE FROM fop2GroupButton WHERE group_name = '$name'","query");
    $results = sql("DELETE FROM fop2groups WHERE id = '$id'","query");
    $results = sql("DELETE FROM fop2UserGroup WHERE id_group = '$id'","query");
    return true;
}

function fop2_edit_group($id,$post) {

    $id = intval($id);
    $thisItem = fop2_get_group($id);
    $name = $thisItem['name'];

    extract($post);

    if (!isset($needconf)) 
        $needconf = '';

    $results = sql("DELETE FROM fop2GroupButton WHERE group_name = '$name'","query");
    $results = sql("SELECT id,device FROM fop2buttons","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $butid[$result['device']]=$result['id'];
        }
    }

    foreach($post['includebot'] as $idx=>$chan){
        $results = sql("INSERT INTO fop2GroupButton (group_name,id_button) VALUES ('$name', '".$butid[$chan]."')");
    }
 
    return true;
}

function fop2_list_groups() {
    $results = sql("SELECT * FROM fop2groups ORDER BY name","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $result){
            $allowed[] = $result;
        }
    }
    if (isset($allowed)) {
        return $allowed;
    } else {
        return null;
    }
}

function fop2_get_group_buttons($name) {
    $ret = Array();
    $results = sql("SELECT id_button FROM fop2GroupButton WHERE group_name='$name'","getAll",DB_FETCHMODE_ASSOC);
    if(is_array($results)){
        foreach($results as $idx => $cols) {
            $ret[]=$cols['id_button'];
        }
        return $ret;
    } else {
        return "";
    }
}


?>
